# knife list

The knife list subcommand is used to view a list of objects on the server. This subcommand works similar to `knife cookbook list`, `knife data bag list`, `knife environment list`, `knife node list`, and `knife role list`, but with a single verb (and a single action).

## Syntax

This argument has the following syntax:

    $ knife list [PATTERN...] (options)

## Options

Note

Review the list of common options available to this (and all) Knife subcommands and plugins.

This subcommand has the following options:

`-1`
  Indicates that only one column of results will be shown. Default: `false`.
`--chef-repo-path PATH`
  The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same as specified by `chef_repo_path` in config.rb.
`--concurrency`
  The number of allowed concurrent connections. Default: `10`.
`-d`
  Indicates that a directory’s children will not be shown when a directory matches a pattern. Default value: `false`.
`-f`, `--flat`
  Indicates that a list of file names will be shown. Set to `false` to view ls-like output. Default: `false`.
`--local`
  Indicates that only contents of the local directory will be returned. Default: `false`.
`-p`
  Indicates that trailing slashes (/) will be shown for directories. Default: `false`.
`-R`
  Indicates that directories will be listed recursively. Default: `false`.
`--repo-mode MODE`
  The layout of the local chef-repo. Possible values: `static`, `everything`, or `hosted_everything`. Use `static` for just roles, environments, cookbooks, and data bags. By default, `everything` and `hosted_everything` are dynamically selected depending on the server type. Default: `everything` / `hosted_everything`.

## Examples

The following examples show how to use this Knife subcommand:

List roles

For example, to view a list of roles on the server:

    $ knife list roles/

List roles and environments

To view a list of roles and environments on the server:

    $ knife list roles/ environments/

List everything

To view a list of absolutely everything on the server:

    $ knife list -R /